# include <stdio.h>

/*
 * Να γραφεί δομή για την περιγραφή των στοιχείων ενός υπάλληλου.
 * Η δομή να περιέχει τουλάχιστον τα ακόλουθα στοιχεία: 
 * Α) Επίθετο Υπάλληλου 2) ΑΜΚΑ 3) Μισθός σε ευρώ 4) Μπόνους σε ευρώ. 
 * Στην συνέχεια να γίνει συνάρτηση main() στην οποία θα δηλώσετε έναν πίνακα από 5 υπάλληλους,
 *  θα διαβάσετε τα στοιχεία του καθενός από αυτά και θα εμφανίσετε για κάθε υπάλληλο 
 * τις αθροιστικές αποδοχές που θα λάβει (Μισθός + Μπόνους), καθώς και το πλήθος των 
 * υπαλλήλων που θα λάβουν λιγότερο από 100 ευρώ σε μπόνους.
 * Να γραφούν στο αρχείο employee.txt οι υπάλληλοι σε φθίνουσα σειρα ως προς
 * το συνολο των αποδοχων
 * **/

# define SIZE 5
typedef struct
{
	char lastname[100];
	char amka[30];
	double salary;
	double bonus;
}Employee;

Employee readEmployee()
{	
	Employee t;
	printf("Dose epitheto \n");
	scanf("%s",t.lastname);
	printf("Dose amka \n");
	scanf("%s",t.amka);
	printf("Dose mistho \n");
	scanf("%lf",&t.salary);
	printf("Dose bonus \n");
	scanf("%lf",&t.bonus);
	return t;
}

void printEmployee(Employee t)
{
	printf("Details: %s %s %lf %lf Total Salary: %lf\n",
	    t.lastname,t.amka,t.salary,t.bonus,t.salary + t.bonus);
}

int main()
{
	FILE *out;
	Employee data[SIZE];
	int i,j;
	int count = 0;
	for(i=0;i<SIZE;i++) 
	{
		printf("Dose epitheto \n");
		scanf("%s",data[i].lastname);
	printf("Dose amka \n");
	scanf("%s",data[i].amka);
	printf("Dose mistho \n");
	scanf("%lf",&data[i].salary);
	printf("Dose bonus \n");
	scanf("%lf",&data[i].bonus);
	}
	
	for(i=0;i<SIZE;i++) 
	  printEmployee(data[i]);
	
	for(i=0;i<SIZE;i++)
	{
		if(data[i].bonus<100) count++;
	}
	
	printf("Count: %d \n",count);
	
	/** taxinomisi pinaka os pros synolikes apodoxes **/
	for(i=0;i<SIZE;i++)
	{
		for(j=0;j<SIZE-1;j++)
		{
			double apodoxes1 = data[j].salary + data[j].bonus;
			double apodoxes2 = data[j+1].salary+data[j+1].bonus;
			if(apodoxes2>apodoxes1)
			{
				Employee temp;
				temp = data[j];
				data[j]=data[j+1];
				data[j+1]=temp;
			}
		}
	}
	
	/** Emfanisi ypallilon **/
	for(i=0;i<SIZE;i++) printEmployee(data[i]);
	
	out = fopen("employee.txt","w");
	for(i=0;i<SIZE;i++)
	{
		fprintf(out,"%s %s %lf %lf\n",data[i].lastname,
		   data[i].amka,data[i].salary,data[i].bonus);
	}
	fclose(out);
	return 0;
}
